/* name: Kathryn Rutti   ID:  9729317
 * section: AG           email: kathrynr@u.washington.edu
 * CSE142, 98 Autumn
 * Homework 4
 * Rain Gods and Goddesses

  STARTER PROGRAM

  To start with, your job is to figure out what this program does.
 *
 *
 */

/* There's a landscape in the background...

*/

#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

/* Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	7

/*color of letter on buttons*/
#define SELECTED_COLOR   YELLOW	 
#define UNSELECTED_COLOW BLACK

#define MAX_PRECIP_EVENTS	500
	/*This is the total number of drops possible at one time.*/

/* y-ccordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))


/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0

/* Types of precipitations we support */
#define NONE 0
#define RAIN 1
#define SNOW 2
#define LIGHTNING 3

/*if you add new types of percip, you may need to change this*/
#define MAX_PRECIP_TYPES 2

/*Possible places for mouse clicks*/
#define BUTTON 1
	/*The above means you clicked on SOME button (doesn't say which one yet)*/
#define DIRT 2
	/*The above means you clicked in the dirt area */
/* max number of drops on the screen at a time*/

#define MAX_DROPS 500

    /*Space Needle constants*/
#define NEEDLE_WIDTH 10
#define TOP_OF_NEEDLE 100
#define OVAL_EDGE 50
#define OVAL_THICKNESS 30
#define NUM_OF_WINDOWS 5

/*cloud constants*/
#define LL_CLOUD_X GP142_XMAX - 250
#define LL_CLOUD_Y GP142_YMAX - 100
#define LL_CLOUD_X1 (-GP142_XMAX) + 100
#define LL_CLOUD_Y1 (-GP142_YMAX) + 340
/*boat constants*/
#define LL_BOAT_X (-GP142_XMAX + 70)
#define LL_BOAT_Y (-2*(GP142_YMAX/5) - 120)

#define LL_BOAT_X1 (-GP142_XMAX + 200)
#define LL_BOAT_Y1 (-2*(GP142_YMAX/5) - 95)

#define LL_BOAT_X2 (GP142_XMAX - 130)
#define LL_BOAT_Y2 (-2*(GP142_YMAX/5) - 95)

/*******************  FUNCTION PROTOTYPES **************************/

	/*redraw all the buttons.
	The parameters tell which button should be highlighted
	*/
void DrawButtons(int current_precip, int current_color);

/*Clear all percipitation, so the landscape is just as originally*/
void ClearAllPrecipitation(int x[], int y[], int color[], int precip[], int num_drops);


/*render (draw) all the precipitation*/
void DrawAllPrecipitation(int num_drops, int precip[], int x[], 
						  int y[], int color[]);

void DrawLandscape(int sun_x, int sun_y, int oval_x, int oval_x1,
                  int boat1_ovalx, int boat2_ovalx, int boat3_ovalx, 
					int elev_y1, int boat1_sail,
				   int boat2_sail, int boat3_sail,
                   int boatline1, int boatline2, int boatline3, int radius);

/*draw one drop*/
void DrawPrecipColumn(int precip_type, int bottom_x, int bottom_y, int color);

void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawLightning (int x, int y, int color);


/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was click, call an appropriate function to handle it*/
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *replant);

/*****************************************************************************

     MAIN

*****************************************************************************/

	/* main() has two chief purposes: to contain the important variables and 
	initialize them,
	and to contain the "event loop," which constantly looks to see if an event has
	happened, and then processes the event by calling an appropriate function.
	*/
int main(void)
{
  int i;
  int num_drops = -1;   /*keeps track of number of drops on screen at a time*/
  int quit = FALSE;
  int mouse_x, mouse_y;
  char key_hit;

  int sun_x =GP142_XMAX - 50, sun_y =GP142_YMAX - 35;

 

/*cloud variables*/
int oval_x =LL_CLOUD_X;
int oval_x1 = LL_CLOUD_X1;

/* size of red light on needle*/
int radius = 1;
int growing = TRUE;

/*x values of bottom of first boat*/
int boat1_ovalx =LL_BOAT_X;

/*x values of bottom of 2nd boat*/
int boat2_ovalx = LL_BOAT_X1;

/*x values of bottom of 3rd boat*/
int boat3_ovalx =LL_BOAT_X2;

/* sail of boat */

int boat1_sail =LL_BOAT_X;
int boat2_sail =LL_BOAT_X1;
int boat3_sail =LL_BOAT_X2;

/* boat line*/

int boatline1 =LL_BOAT_X;
int boatline2 =LL_BOAT_X1;
int boatline3 =LL_BOAT_X2;


/* elevator */

int elev_y1 = TOP_OF_DIRT;
int going_up = TRUE;

/* arrays*/
  int x[MAX_DROPS];
  int y[MAX_DROPS];
  int color[MAX_DROPS];
  int precip[MAX_DROPS];

  
  /* 
   * The next items tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower.
   */
  int precip_type = NONE;
  int  precip_color;
 
  int current_precip = NONE, current_color = NONE; /*what to draw next */
  
  /*This flag will be true if all weather should be cleared*/
  int clear_flag = FALSE;

  /*what kind of click was there?*/
  int mouse_click;

  int event; /*the most recent GP142 event*/

  time_t t; /*needed only when initializing a random number generator*/

  /*
   * INITIALIZATIONS
   */

      
  srand (time(&t));	      /* Seed the random number generator             */
		/*This is something you should do if you plan to use random numbers.
		Put it here in your program and forget about it.
		*/

  GP142_open();           /* Open and init the GP142 Graphics Window      */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */

  GP142_clear();	      /* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will grow         */


  DrawLandscape(sun_x, sun_y, oval_x, oval_x1, boat1_ovalx, 
                   boat2_ovalx, boat3_ovalx, elev_y1, boat1_sail, 
                   boat2_sail, boat3_sail, boatline1, boatline2, boatline3,
				   radius);
  DrawButtons(current_precip, current_color);	  /* Show the buttons...*/ 
  ClearAllPrecipitation (x, y, color, precip, num_drops);


  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  while (!quit) {  /*this is the famous "event loop" */

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop           */
      break;

    case GP142_KBD:
		/*not needed for this program.*/
		/*Use this if user will need to hit a key.
		/*Note that scanf CANNOT be used with GP142*/
      break;

    case GP142_MOUSE:
		/* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	if (mouse_click == BUTTON) {
			/* a button has been clicked.  Call a function to handle it*/
		handle_button(mouse_x, mouse_y, 
		      &current_precip, &current_color, &clear_flag);
 
	if (clear_flag == TRUE)
			ClearAllPrecipitation( x, y, color, precip, num_drops);
                                    
		 
	} else if ((mouse_click != DIRT)
		/*it's not a button, and it's not the dirt, so it must be sky*/
		&& 
		 (current_precip != NONE) && (current_color != NONE)){
		
	num_drops++;
	x[num_drops] = mouse_x;
	y[num_drops] = mouse_y;
	color[num_drops] = current_color;
	precip[num_drops] = current_precip;
	}
      
      break;

    case GP142_PERIODIC:
      	
        for(i=0; i<=num_drops; i++){
			if(precip[i]==SNOW)
				 y[i] = y[i] - 2;
		
			else
				y[i] = y[i] - 4;
  
       if(y[i] < TOP_OF_DIRT - 25){
           y[i] = GP142_YMAX;
	   }
        }
	


/* change size of red light on needle */
	if(growing == TRUE && radius < 5)
		radius++;
	if(growing == TRUE && radius == 5) {
		growing = FALSE;
		radius--;}
	if(growing == FALSE && radius > 0)
		radius--;
	if(growing == FALSE && radius == 0){
		growing = TRUE;
		radius++;}
       
/*move boats*/

        boat1_ovalx++;
        boat2_ovalx++;
        boat3_ovalx++;

        boat1_sail++;
        boat2_sail++;
        boat3_sail++;

        boatline1++;
        boatline2++;
        boatline3++;

        if(boat3_ovalx > GP142_XMAX + 40){
            boat3_ovalx = -boat3_ovalx;
            boat3_sail = -boat3_sail;
            boatline3 = -boatline3;
        }

         if(boat2_ovalx > GP142_XMAX + 40){
            boat2_ovalx = -boat2_ovalx;
            boat2_sail = -boat2_sail;
            boatline2 = -boatline2;
        }
          if(boat1_ovalx > GP142_XMAX + 40){
            boat1_ovalx = -boat1_ovalx;
            boat1_sail = -boat1_sail;
            boatline1 = -boatline1;
        }


/*move the clouds*/

		  oval_x = oval_x - 2;
		  if(oval_x < -GP142_XMAX - 120)
			  oval_x = -oval_x;

		  oval_x1= oval_x1 - 2;
			if(oval_x1 < -GP142_XMAX - 120)
				oval_x1 = -oval_x1;
     


     
/* change the red light on the top of the space needle */
	
	if (going_up==TRUE && elev_y1 < TOP_OF_NEEDLE)
		elev_y1++;
	if (going_up==TRUE && elev_y1 == TOP_OF_NEEDLE) {
		going_up = FALSE;
		elev_y1--;}
	if (going_up == FALSE && elev_y1 > TOP_OF_DIRT)
		elev_y1--;
	if (going_up == FALSE && elev_y1 == TOP_OF_DIRT){
		going_up = TRUE;
		elev_y1++;}

   	

		/*and change the sun's position a little bit*/
		sun_x--;


		if (sun_x < -GP142_XMAX -30) {
			sun_x = - sun_x;
			sun_y = sun_y -1;

				/* over a long period of time, the sun will set.
            */
		}

      break;

    default:

      break;
	
    }  /*end switch */

    /* Redraw everything */
    DrawLandscape(sun_x, sun_y, oval_x, oval_x1, boat1_ovalx, 
                boat2_ovalx, boat3_ovalx, elev_y1, boat1_sail, boat2_sail,
                boat3_sail, boatline1, boatline2, boatline3, radius);
    DrawButtons(current_precip, current_color);
    DrawAllPrecipitation(num_drops, precip, x, y, color);

  }  /* end event loop */

  


  /*
   * WRAP-UP
   */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


	/*reinitialize so that ALL current precipitation is erased.*/
	
void  ClearAllPrecipitation(int x[], int y[], int color[], int precip[], int num_drops)
{
  int i;
  for(i=0; i<=num_drops; i++){
      x[i] = 0;
      y[i] = 0;
      color[i] = 0;
      precip[i] = 0;
  }
}



#define RAINDROP_WIDTH 3

void DrawRainDrop (int color, int x, int y) { 

	
    GP142_circleXY(color,
                    x, y,
                    RAINDROP_WIDTH);

    GP142_triangleXY(color,
                    x-3, y,
                    x+3, y,
                    x, y+6,
                    FILL);
    
 
}

#define SNOWDROP_WIDTH 4
#define SNOWDROP_HEIGHT 5

void DrawSnowDrop (int color, int x, int y) {

	GP142_lineXY(color,
				x+7, y,
				x-7, y,
				1);
	GP142_lineXY(color,
				x, y+7,
				x, y-7,
				1)	;
	GP142_lineXY(color,
				x-3, y+3,
				x+4, y-4,
				1);	
	GP142_lineXY(color,
				x+3, y+3,
				x-4, y-3,
				1);
}

void DrawLightning (int color, int x, int y) {
   
   GP142_lineXY(color,
                x-3, y+3,
                x, y,
                RAINDROP_WIDTH);
    GP142_lineXY(color,
                x, y,
                x-3, y-3,
                RAINDROP_WIDTH);
    GP142_lineXY(color,
                x-3, y-3,
                x, y-6,
                RAINDROP_WIDTH);


}



void DrawAllPrecipitation(int num_drops, int precip[], int x[], int y[], int color[])
{
	int i;

	for(i=0; i<=num_drops; i++) {


	if (y[i] >= TOP_OF_DIRT - 20) {
		switch (precip[i]) {
		case RAIN:
			DrawRainDrop (color[i],x[i], y[i]);
			break;
		case SNOW:
			DrawSnowDrop (color[i], x[i], y[i]);
			break;
        case LIGHTNING:
            DrawLightning (color[i], x[i], y[i]);
            break;
		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/
		
		}
	} /*end for statement*/
}



int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;

}


void DrawLandscape(int sun_x, int sun_y, int oval_x, int oval_x1,
                  int boat1_ovalx, 
                   int boat2_ovalx, int boat3_ovalx, 
                   int elev_y1, int boat1_sail, int boat2_sail,
                   int boat3_sail, int boatline1, int boatline2, int boatline3, 
				   int radius)
{  
int text_offset = -GP142_XMAX + 15, font_size = 12;
int i;

 /* int oval_x1 =GP142_XMAX - 100;
  int oval_x =GP142_XMAX - 250;*/


  int oval_y =GP142_YMAX - 100;
  int oval_y1 =GP142_YMAX - 50;
  int oval_y2 =LL_CLOUD_Y - 100;
  int oval_y3 =LL_CLOUD_Y -25;

  /* Draw the sky first */
  GP142_rectangleXY(BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
 
  /* Draw the sun */
  GP142_circleXY(YELLOW, sun_x, sun_y , 20);

/*CLOUDS*/

      GP142_ovalXY(WHITE,
        oval_x, LL_CLOUD_Y,
        oval_x + 150, LL_CLOUD_Y +40,
        FILL);
    GP142_ovalXY(WHITE,
       oval_x1, LL_CLOUD_Y1,
        oval_x1 + 150, LL_CLOUD_Y1 + 50,
        FILL);



  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);
  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");

  
  /*Draw the mountains */
  GP142_triangleXY(DUSTY_PLUM,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   -75, (2 * GP142_YMAX)/5 ,
		   FILL);

  GP142_triangleXY(OLIVE,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4 +20, (1 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX+150, TOP_OF_DIRT,
		   GP142_XMAX -110, (1 * GP142_YMAX)/3 ,
		   FILL);

  /*Draw Tree*/
  GP142_rectangleXY(BROWN,
			( GP142_XMAX/2 - 10), TOP_OF_DIRT,
			(GP142_XMAX/2 +10), (TOP_OF_DIRT + 30),
			FILL);



  for(i=0; i<= 2; i+=1) {

GP142_triangleXY(OLIVE,
                GP142_XMAX/2, (TOP_OF_DIRT + 100 - (i*25)),
                (GP142_XMAX/2 - 30 - (i*20)), (TOP_OF_DIRT + 70 - (i*25)),
                (GP142_XMAX/2 + 30 + (i*20)), (TOP_OF_DIRT + 70 - (i*25)),
                FILL);

/*left point of tree*/
GP142_circleXY(MAGENTA,
			   (GP142_XMAX/2 - 30 - (i*20)), (TOP_OF_DIRT + 70 - (i*25)),
			   5);
/*right point of tree*/

GP142_circleXY(MAGENTA,
			(GP142_XMAX/2 + 30 + (i*20)), (TOP_OF_DIRT + 70 - (i*25)),
			5);
 }

  /*top point*/
GP142_circleXY(CHALK,
			GP142_XMAX/2, (TOP_OF_DIRT + 100),
			5);

GP142_rectangleXY(BROWN,
			(-( GP142_XMAX/2 - 10)), TOP_OF_DIRT,
			(-(GP142_XMAX/2 +10)), (TOP_OF_DIRT + 30),
			FILL);


    for(i=0; i<= 2; i+=1) {


GP142_triangleXY(FOREST_GREEN,
                (-(GP142_XMAX/2)), (TOP_OF_DIRT + 100 - (i*25)),
                (-(GP142_XMAX/2 - 30 - (i*20))), (TOP_OF_DIRT + 70 - (i*25)),
                (-(GP142_XMAX/2 + 30 + (i*20))), (TOP_OF_DIRT + 70 - (i*25)),
                FILL);

/*left point of tree*/
GP142_circleXY(PINK,
			   (-GP142_XMAX/2 - 30 - (i*20)), (TOP_OF_DIRT + 70 - (i*25)),
			   5);
/*right point of tree*/

GP142_circleXY(PINK,
			(-GP142_XMAX/2 + 30 + (i*20)), (TOP_OF_DIRT + 70 - (i*25)),
			5);

  }

	  /*top point*/
GP142_circleXY(YELLOW,
			-GP142_XMAX/2, (TOP_OF_DIRT + 100),
			5);



  /*Draw Space Needle*/
 
  GP142_lineXY(LT_GRAY,
               0, TOP_OF_DIRT,
               0, TOP_OF_NEEDLE,
               NEEDLE_WIDTH);


  GP142_rectangleXY(LT_GRAY,
                    -5, TOP_OF_DIRT - 10,
                    4, TOP_OF_DIRT,
                    FILL);
    /*STANDS*/
   GP142_lineXY(LT_GRAY,
                0, TOP_OF_DIRT + 50,
                40, TOP_OF_DIRT,
                NEEDLE_WIDTH-2);
   GP142_lineXY(LT_GRAY,
                0, TOP_OF_DIRT + 50,
                -40, TOP_OF_DIRT,
                NEEDLE_WIDTH -2);

     /*elevator rope*/
    GP142_lineXY(BLACK,
               -3, TOP_OF_DIRT,
               -3, TOP_OF_NEEDLE,
               1);
/*elevator*/
	 GP142_rectangleXY(BLACK,
                    -7, elev_y1,
                    0, elev_y1+12,
                    3);

   

   GP142_ovalXY(BLACK,
               -(OVAL_EDGE+1), TOP_OF_NEEDLE+1,
               OVAL_EDGE+ 1, TOP_OF_NEEDLE + OVAL_THICKNESS + 1,
               1);


     GP142_ovalXY(BLACK,
               -(2*(OVAL_EDGE)/3 +1), TOP_OF_NEEDLE + OVAL_THICKNESS - 10 +1,
               2*(OVAL_EDGE)/3 +1, TOP_OF_NEEDLE + 2*OVAL_THICKNESS - 10 +1,
               1);
                   
   
   /*first/bottom OVAL*/
   GP142_ovalXY(LT_GRAY,
               -(OVAL_EDGE), TOP_OF_NEEDLE,
               OVAL_EDGE, TOP_OF_NEEDLE + OVAL_THICKNESS,
               FILL);

     GP142_ovalXY(LT_GRAY,
               -2*(OVAL_EDGE)/3, TOP_OF_NEEDLE + OVAL_THICKNESS - 10,
               2*(OVAL_EDGE)/3, TOP_OF_NEEDLE + 2*OVAL_THICKNESS - 10,
               FILL);

/* top needle part*/
       GP142_lineXY(LT_GRAY,
               0, TOP_OF_NEEDLE + 2*OVAL_THICKNESS-10,
               0, (TOP_OF_NEEDLE + 2*OVAL_THICKNESS-10) + 30,
               NEEDLE_WIDTH/3);

 /*the weedle of the needle*/
    GP142_circleXY(RED,
                   0, (TOP_OF_NEEDLE + 2*OVAL_THICKNESS-10) + 30,
                   radius);

    /*windows*/


    for(i=0; 
        i <= (NUM_OF_WINDOWS); 
        i+=1) {
        
        GP142_circleXY(BLACK,
                       (-(OVAL_EDGE) + 10) + (i*15), 
                       TOP_OF_NEEDLE + OVAL_THICKNESS/2,
                        4);
    }

	

    

	 /* river */
	 GP142_rectangleXY(CYAN,
					-GP142_XMAX, TOP_OF_DIRT-25,
					GP142_XMAX, -GP142_YMAX+25,
					FILL);

	 GP142_lineXY(CYAN,
				-GP142_XMAX, 0,
				-GP142_XMAX+50, -50,
				30);
	 GP142_lineXY(CYAN,
				-GP142_XMAX+50, -50,
				-GP142_XMAX, -GP142_YMAX+50,
				30);


/*BOAT 1*/


	 GP142_ovalXY(RED,
		 boat1_ovalx, LL_BOAT_Y,
		boat1_ovalx+50, LL_BOAT_Y + 20,
					FILL);

	GP142_triangleXY(YELLOW,
				boat1_sail, LL_BOAT_Y+15,
				boat1_sail + 50, LL_BOAT_Y+15,
				boat1_sail + 25, LL_BOAT_Y+60,
				FILL);
	GP142_lineXY(CYAN,
				boatline1 + 25, LL_BOAT_Y + 16,				
				boatline1 + 25, LL_BOAT_Y+60,
				3);


/*BOAT 2*/


	 GP142_ovalXY(NAVY_BLUE,
		 boat2_ovalx, LL_BOAT_Y1,
		boat2_ovalx+50, LL_BOAT_Y1 + 20,
					FILL);

	GP142_triangleXY(ORANGE,
				boat2_sail, LL_BOAT_Y1+15,
				boat2_sail + 50, LL_BOAT_Y1+15,
				boat2_sail + 25, LL_BOAT_Y1+60,
				FILL);


	GP142_lineXY(CYAN,
				boatline2 + 25, LL_BOAT_Y1 + 16,				
				boatline2 + 25, LL_BOAT_Y1+60,
				3);

/*BOAT 3*/


	 GP142_ovalXY(RED,
		 boat3_ovalx, LL_BOAT_Y2,
		boat3_ovalx+50, LL_BOAT_Y2 + 20,
					FILL);

	GP142_triangleXY(GREEN,
				boat3_sail, LL_BOAT_Y2+15,
				boat3_sail + 50, LL_BOAT_Y2+15,
				boat3_sail + 25, LL_BOAT_Y2+60,
				FILL);
	GP142_lineXY(CYAN,
				boatline3 + 25, LL_BOAT_Y2 + 16,				
				boatline3 + 25, LL_BOAT_Y2+60,
				3);

	 
} /*end DrawLandscape */


/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *clear_weather)
{
  int max_speed = 80;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  case 2:
   *current_precip = LIGHTNING;
    break;
  case 3:
    *current_color = WHITE;
    break;
  case 4:
    *current_color = ICE_BLUE;
    break;
  case 5:
	 *current_color = YELLOW;
	break;
  case 6:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  default:
		/*Bad news if this is ever reached! */
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }

}


/* Draws the buttons */
void DrawButtons(int current_precip, int current_color)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Snow");

  i -= BUTTON_HEIGHT;
  if (current_precip == LIGHTNING)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Lightning");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Lightning");

 
 
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == ICE_BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Blue");

    i -= BUTTON_HEIGHT;
  if (current_color == YELLOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Yellow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Yellow");

  /* This button is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Cease!");

}


void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}